import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class BouncingBalls extends JFrame implements MouseListener {

      private JPanel canvas;
      private int nbouncing = 0;
      private int bouncing_limit;
    
      public BouncingBalls(int bouncing_limit) {
	    setDefaultCloseOperation(EXIT_ON_CLOSE); // DISPOSE_ON_CLOSE
	    setTitle("Exemplo de threads");
	    // pegar a referencia do contentpane do JFrame atual
	    Container contentPane = getContentPane();
	    // crio um JPanel
	    canvas = new JPanel();
	    canvas.setSize(400,400); // configura tamanho
	    // incluo o JPanel no contentpane do JFrame
	    contentPane.add(canvas,"Center");
	    this.setSize(400,400);
	    this.setVisible(true);
	    this.bouncing_limit = bouncing_limit;
	    canvas.addMouseListener(this);
      }
      public void mouseClicked(MouseEvent e) { 
	    int dx = (int)(Math.random()*2)-1;
	    int dy = (int)(Math.random()*2)-1;
	    dx = ((dx == 0) && (dy == 0)) ? 1 : dx;
	    Ball ball = new Ball(canvas, dx, dy, this);
	    int x = e.getX();
	    int y = e.getY();
	    ball.setX(x);
	    ball.setY(y);
	    ball.start();
      }
      public void mousePressed(MouseEvent e) { }
      public void mouseReleased(MouseEvent e) { }
      public void mouseEntered(MouseEvent e) { }
      public void mouseExited(MouseEvent e) { }
      
      public void startedBouncing () { nbouncing++; }
      public void stoppedBouncing () { nbouncing--; }
      public boolean reachedLimit() { return (nbouncing >= bouncing_limit); }

      public static void main (String args[]) {
	    int nbb = 5;
	    if (args.length > 0) {
		nbb = (int)Integer.parseInt(args[0]);
	    }
	    BouncingBalls app = new BouncingBalls(nbb);
      }
} 
